module data.qlist {
   constructor: '{}'/1.

   member(X, { X }).
   member(X, (A . _B)) :-
      member(X, A).
   member(X, (_A . B)) :-
      member(X, B).

   length([]) = 0.
   length({ _X }) = 1.
   length((A . B)) = data.number:(length(A) + length(B)).

   of_list([]) = [].
   of_list([H | T]) = ({ H } . of_list(T)).

   append_to_list([], L) = L.
   append_to_list({ X }, L) = [X | L].
   append_to_list((A . B), L) = append_to_list(A, append_to_list(B, L)).

   to_list(A) = append_to_list(A, []).

   reverse([]) = [].
   reverse({ X }) = { X }.
   reverse((A . B)) = (reverse(B) . reverse(A)).

   delete([], _) = [].
   delete({ X }, X) = ! >> [].
   delete({ _X }, _Y) = { _X }.
   delete((A . B), X) = (delete(A, X) . delete(B, X)).

   select(X, { X }) = [].
   select(X, (A . B)) = (select(X, A) . B).
   select(X, (A . B)) = (A . select(X, B)).

   iter([], _F).
   iter({ X }, F) :-
      F:do(X).
   iter((A . B), F) :-
      iter(A, F),
      iter(B, F).
}
